fieldset.options {
    clear:both;
    border:1px solid #ccc;
}
fieldset.options legend {
    font-family: Georgia,"Times New Roman",Times,serif;
    font-size: 22px;
}
.editable {
	color: #000;
	background-color: #ffffd3;
}
.blankedit {
	color: #ccc;
	font-size: 9px!important;
	font-style: italic!important;
	font-weight: none!important;
}
.weightedit {
	width: 200px;
	font-size: 18px;
	font-weight: bold;
}

    .trend_dif {
        font-size: small;
        vertical-align: 50%;
    }

    .good_trend {
        color: green;
    }

    .bad_trend {
        color: red;
    }

.hackdiet_edit_text {
	width: 50px;
}
.hackdiet_edit_button {

}
.hackdiet_cancel_button {

}
h3.title {
	font: 100 186%/1.1 constantia, georgia, serif;
	color: #75C20F;
	letter-spacing:-0.02em;
}
#hackdiet_zeitgeist {
	background: #eee;
	border: 1px solid #69c;
	font-size: 90%;
	margin-right: 1em;
	margin-top: 4em;
	padding: 1em;
}

#hackdiet_zeitgeist h2, fieldset legend a {
	border-bottom: none;
}

#hackdiet_zeitgeist h2 {
	margin-top: .4em;
}

#hackdiet_zeitgeist h3 {
	border-bottom: 1px solid #ccc;
	font-size: 16px;
	margin: 1em 0 0;
}

#hackdiet_zeitgeist h3 cite {
	font-size: 12px;
	font-style: normal;
}

#hackdiet_zeitgeist li, #zeitgeist p {
	margin: .2em 0;
}

#hackdiet_zeitgeist ul {
	margin: 0 0 .3em .6em;
	padding: 0 0 0 .6em;
}

<?php  
$options = hackdiet_get_options($user_ID);

// first time they open the page, we need to set default unit
if (!$options["unit"]) {
	$options["unit"] = "lb";
	hackdiet_save_options($user_ID, $options);
}

if ($_SERVER["REQUEST_METHOD"] == "POST") {

	if ($_POST["goal_date"] && !$_POST["goal_weight"]) {
		// can't plan without a plan
		$error = "So exactly how much would you like to weigh on " . $_POST["goal_date"] . "?";
	} else {
//			$options["unit"] = $_POST["unit"];

		$options["goal_weight"] = $_POST["goal_weight"];
		$options["goal_date"] = $_POST["goal_date"];
          if ($_POST["maint_mode"]) {
              $options["maint_mode"] = true;
          } else {
              $options["maint_mode"] = "";
          }

		hackdiet_save_options($user_ID, $options);

		if ($_POST["unit"] != $_POST["old_unit"]) {
			convert_weights($_POST["old_unit"], $_POST["unit"]);
		}
	}
}

?>
<?php if ($error):?>
<div id="message" class="error fade"><p><strong><?php echo $error?></strong></p></div>
<?php elseif ($message):?>
<div id="message" class="updated fade"><p><strong><?php echo $message?></strong></p></div>
<?php endif;?>



<div id="file_path" style="display: none;"><?= PLUGIN_PATH ?></div>
  
<div class="wrap">
	<h2 id="write-post">The Hacker's Diet</h2>

	<?
	if ($_GET["section"] == "reports") {
		/*********************************************
		*                                            *
		*                                            *
		*              REPORTING SCREEN              *
		*                                            *
		*                                            *
		*********************************************/

		if ($_GET["show"] == "all") {
			$query = "select min(date) as max, max(date) as min from ".$table_prefix."hackdiet_weightlog where wp_id = $user_ID";
			$row = $wpdb->get_row($query);
			$_GET['start_date'] = $row->max;
			$_GET['end_date']= $row->min;
		}

		?>
		<table width="100%">
			<form method="get" action="<?=$_SERVER["PHP_SELF"]?>">
			<input type="hidden" name="page" value="<?=$_GET["page"]?>">
			<input type="hidden" name="section" value="<?=$_GET["section"]?>">
			<tr>
				<td width="33%" align="center">
					From: <input type="text" id="start_date" name="start_date" class="format-y-m-d divider-dash" value="<?=$_GET['start_date']?>">
				</td>
				<td width="33%" align="center">
					To: <input type="text" id="end_date" name="end_date" class="format-y-m-d divider-dash" value="<?=$_GET['end_date']?>">
				</td>
				<td align="center">
					<input type="submit" value="run report &gt;" />
				</td>
			</tr>
			</form>
			<tr>
				<td colspan="3" align="center">
					<br>
					<br>
					<img id="main_graph" src="<?=PLUGIN_FOLDER_URL?>/hackersdiet_chart.php?user=<?=$user_ID?>&start_date=<?=$_GET['start_date']?>&end_date=<?=$_GET['end_date']?>&goal=<?=$options["goal_weight"]?>&maint_mode=<?=$options["maint_mode"]?>">
					<div id="blurb">
					<?
						include(dirname(__FILE__).'/ajax_blurb.php');
					?>
					</div>
				</td>
			</tr>
		</table>
		<?
		
	} else if ($_GET["section"] == "edit") {
    /*********************************************
    *                                            *
    *                                            *
    *                 EDIT SCREEN                *
    *                                            *
    *                                            *
    *********************************************/
    echo "Edit screen not yet implemented... it's next on my list, I promise! :]";
	} else {
		/**********************************************
		*                                             *
		*                                             *
		*                  MAIN PAGE                  *
		*                                             *
		*                                             *
		**********************************************/
		?>
		<table width="100%">
			<tr>
				<td rowspan="2" width="30%" valign="top">
					<input type="hidden" id="user_id" name="user_id" value="<?=$user_ID?>">
					<table>
						<tr>
							<th>Date</th>
							<th>Weight (<?=$options["unit"]?>s)</th>
							<?
							$date_index = strtotime("now");
							for ($i = 0; $i < 14; ++$i) {
								$weight_array[date("Y-m-d", $date_index)] = array("weight" => "", "trend" => "", "rung" => "");
								$date_index = strtotime("yesterday", $date_index);
							}

							$query = "select date, weight, trend from ".$table_prefix."hackdiet_weightlog where wp_id = $user_ID and date > '".date("Y-m-d", strtotime("2 weeks ago"))."' order by date desc";
							$dbweights = $wpdb->get_results($query);
							if ($dbweights) {
								foreach ($dbweights as $weight) {
									$weight_array[$weight->date]["weight"] = $weight->weight;
									$weight_array[$weight->date]["trend"] = $weight->trend;
								}
							}
							foreach ($weight_array as $date => $weight) {
                                  $dif = round($weight["weight"] - $weight["trend"], 1);
								?>
								<tr>
									<td nowrap align="right"><?=date("D n/j", strtotime($date))?></td>
									<td><div class="weightedit <?=($weight["weight"]?"":"blankedit")?>" id="weight_<?=strtotime($date)?>"><?=($weight["weight"]?round($weight["weight"], 1) . "<span class=\"trend_dif ".(($dif < 0)?"good_trend":"bad_trend")."\">$dif</span>":"click here to add a weight")?></div></td>
								</tr>
								<?
							}
							?>
						</tr>
					</table>
				</td>
				<td align="center" valign="top">
                      <div id="togo">
                      <?
						include(dirname(__FILE__).'/ajax_togo.php');
					?>
                      </div>
					<img id="main_graph" src="<?=PLUGIN_FOLDER_URL?>/hackersdiet_chart.php?user=<?=$user_ID?>&weeks=2&goal=<?=$options["goal_weight"]?>&maint_mode=<?=$options["maint_mode"]?>">
					<br>
				</td>
			</tr>
			<tr>
				<td align="center" valign="top" height="100%">
					<div id="blurb">
					<?
						include(dirname(__FILE__).'/ajax_blurb.php');
					?>
					</div>
					<br>
				</td>
			</tr>
		</table>
		<table width="100%">
			<tr>
				<td width="25%">
					<div id="hackdiet_zeitgeist" align="left">
						<h2><?php _e('More &raquo;'); ?></h2>
						<div>
							<h3><?php _e('Charts'); ?></h3>
							<?
							$report_url = $_SERVER['PHP_SELF']."?page=hackersdiet.php&section=reports";
							?>
							<ul>
								<li><a href="<?=$report_url . "&start_date=".date("Y-m-01")."&end_date=".date("Y-m-t")?>">Monthly</a></li>
								<li><a href="<?=$report_url . "&start_date=".date("Y-m-01", strtotime("-2 months"))."&end_date=".date("Y-m-t")?>">Quarterly</a></li>
								<li><a href="<?=$report_url . "&start_date=".date("Y-01-01")."&end_date=".date("Y-m-d")?>">Year to date</a></li>
								<li><a href="<?=$report_url . "&show=all"?>">Complete history</a></li>
							</ul>
						</div>
						<div>
						  <h3><?php _e('Actions') ?></h3>
						  <ul>
						    <li><a href="<?= $_SERVER['PHP_SELF']."?page=hackersdiet.php&section=edit" ?>">Edit older weights</a></li>
						  </ul>
						</div>
						<div>
							<h3><?php _e('Updates'); ?></h3>
							<?
								if ( file_exists(ABSPATH . WPINC . '/rss.php') )
									require_once(ABSPATH . WPINC . '/rss.php');
								else
									require_once(ABSPATH . WPINC . '/rss-functions.php');

								$rss = fetch_rss('http://www.afex2win.com/stuff/hackersdiet/feed/');
								if ( isset($rss->items) && 0 != count($rss->items) ) {
									$rss->items = array_slice($rss->items, 0, 3);
									echo "<ul>";
									foreach ($rss->items as $item ) {
										?>
										<li><a href='<?php echo wp_filter_kses($item['link']); ?>'><?php echo wp_specialchars($item['title']); ?></a> &#8212; <?php printf(__('%s ago'), human_time_diff(strtotime($item['pubdate'], time() ) ) ); ?></li>
										<?
									}
									echo "</ul>";
								}
							?>
                              <br/><br/>(Your version is <?= $hd_version ?>)
						</div>
					</div>
				</td>
				<td>
					<fieldset class="options">
						<legend>Settings</legend>
						<form method="post">
							<table id="weighttable" width="100%">
								<colgroup width="20%" align="right"></colgroup>
                                  <colgroup width="30%" align="left"></colgroup>
                                  <colgroup width="20%" align="right"></colgroup>
                                  <colgroup width="30%" align="left"></colgroup>
                                  <!--
								<tr>
									<td><b>Unit:</b></td>
									<td>
										<input type="hidden" id="old_unit" name="old_unit" value="<?=$options["unit"]?>">
										<input type="radio" id="unit" name="unit" value="lb" <?=($options["unit"]=="lb"?"checked":"")?>>&nbsp;Pounds (lb)&nbsp;
										<input type="radio" id="unit" name="unit" value="kg" <?=($options["unit"]=="kg"?"checked":"")?>>&nbsp;Kilograms (kg)
									</td>
								</tr>
                                  -->
								<tr>
									<td><b>Goal Weight:</b></td>
									<td><input type="text" id="goal_weight" name="goal_weight" value="<?=$options["goal_weight"]?>"></td>
                                      <td>Maintenance mode?</td>
                                      <td>
                                          <input type="checkbox" id="maint_mode" name="maint_mode" <?= ($options["maint_mode"]?"checked":"") ?>>
                                          <?
                                          if ($options["goal_weight"] && $current_trend <= $options["goal_weight"] && !$options["maint_mode"]) {
                                              echo "<span class=\"bad_trend\">Just hit your goal?<br/>Select Maintenance mode.</span>";
                                          }
                                          ?>
                                      </td>
								</tr>
								<tr>
									<td><b>Goal Date:</b></td>
									<td><input type="text" id="goal_date" name="goal_date" value="<?=($_POST["goal_date"] ? $_POST["goal_date"] : $options["goal_date"])?>" class="format-y-m-d divider-dash range-low-<?= date("Y-m-d") ?>"></td>
								</tr>
								<tr>
									<td colspan="4">
										<p class="submit"><input type="submit" value="save settings &gt;" /></p>
									</td>
								</tr>
							</table>
						</form>
					</fieldset>
				</td>
			</tr>
		</table>
		<?
	}
      ?>

</div>
<?